<%--
 * Component: dotcom
 *
 * Description:
 *    Draws dotcom hierarchy.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.imsession.*, imagemed.util.*, imagemed.dotcom.*, java.util.*, java.io.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

	static String getDevInfo( DotcomDevice device ) {
		IMProperties dicomSettings = device.getDICOMSettings();
		String host = dicomSettings.getProperty( "HOST" );
		String ip = dicomSettings.getProperty( "SERVERIP" );
		return device.getId() + " (" + host + " - " + ip + ")";
	}

%><%

	IMSession is = new IMSession( request, response, out );
	is.bRegNotNeeded = false;
	is.bCheckHttpsAndRedirect = false;

	boolean preferIp = "true".equals( request.getParameter( "preferIp" ) );
	boolean isInFrame = "true".equals( request.getParameter( "inFrame" ) );
	
%><HTML><HEAD><TITLE>Dotcom Hierarchy</TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
%>
<SCRIPT language="JavaScript">

   function goparent_( device ) {
			window.parent.location = device;
	}

</SCRIPT>

</HEAD><BODY>

<%
	DotcomConfig dotcomConfig = DotcomConfig.getConfig();
	DotcomDevice selfDevice = DotcomConfig.selfDevice();
	String selfId = DotcomConfig.selfId();

%>

<TABLE border=0 width="100%" cellpadding=0 cellspacing=0 align="center"><TR><TD align="center" style="vertical-align: top;">

<DIV style="text-align: center; color: blue; font-size: 18pt; font-weight: bold; padding: 20px;">
        <%= selfId %>
</DIV>
<DIV style="text-align: center; color: blue; font-size: 14pt; font-weight: bold;">
        (<%= IMEnvBase.getEnv( "SERVERNAME" ) %> - <%= IMEnvBase.getEnv( "SERVERIP" ) %>)
</DIV>

<%
{
	String parent = DotcomConfig.selfParent();
	if ( parent != null ) {
		DotcomDevice parentDev = dotcomConfig.getDevice( parent );
%>
<DIV style="text-align: center; color: blue; font-size: 12pt; padding-top: 30px;">
        Parent:<BR><%= getDevInfo( parentDev ) %>
</DIV>
<%		
	}
}

{
	String[] children = DotcomConfig.selfChildren();
	if ( children != null && children.length != 0 ) {
%>
<DIV style="text-align: center; color: blue; font-size: 12pt; padding-top: 30px;">
<%= ( children.length == 1 ) ? "Child" : "Children" %>:
  <TABLE align="center" border=0 cellpadding=0 cellspacing=0>
<%
		for( int i = 0; i < children.length; i++ )  {
			DotcomDevice childDev = dotcomConfig.getDevice( children[ i ] );
%>
	<TR><TD align="left" style="font-size: 12pt; color: blue;">
	<%= getDevInfo( childDev ) %><BR>
	</TD></TR>
<%
		}
%>
</TABLE>
</DIV>
<%
	}
}

%>

</TD><TD align="center" style="vertical-align: center;">

<%
	File dotcominfo = new File( IMEnvBase.getEnv( "MAIN_DATA" ) + "/dotcominfo.png" );
	File infomap = new File( IMEnvBase.getEnv( "MAIN_DATA" ) + "/dotcominfo.cmap" );

	if ( ! dotcominfo.exists() || ! infomap.exists() ) {

		Map<String, Device> devices = DotcomConfig.getConfig().getDevices();
		FileWriter fileWriter = new FileWriter( IMEnvBase.getEnv( "TMP" ) + "/dotcomgraph.dot" );
		fileWriter.write( "graph tdotcom {\n" );

		for ( Iterator<Device> e = devices.values().iterator() ; e.hasNext() ; ) {
			Device d = e.next();
			String dDev = d.getId();
			String dDevice = dDev.replaceAll( "-", "_dash_" );
	
			if ( d instanceof DotcomDevice ) {
				String filledAttr = ( dDevice.equals( selfId ) ) ? "style = filled, fillcolor = lightgrey, " : "";
				DotcomDevice dd = ( DotcomDevice ) d;
				String[] childr = dd.getChildren();
				for ( int i = 0; i < childr.length; i++ ) {
					String child = childr[ i ];
					String children = child.replaceAll( "-", "_dash_" );
					fileWriter.write( dDevice + " -- " + children + ";\n" );
				}
				String url = null;
				if ( ! dDevice.equals( selfId ) ) {
					IMProperties dicomSettings = dd.getDICOMSettings();
					String host = preferIp
							? dicomSettings.getProperty( "SERVERIP", dicomSettings.getProperty( "HOST" ) )
							: dicomSettings.getProperty( "HOST", dicomSettings.getProperty( "SERVERIP" ) );
					if ( host != null ) {
						url = "http://" + host + "/";
					}
				}
				fileWriter.write( dDevice + " [shape = record, " );
				if ( url != null ) {
					fileWriter.write( "URL = \"" + url + "\", " ); 
				}
				fileWriter.write( "color = black, " + filledAttr + "label = \"" + dDevice + " \"]\n" );
			}
		}

		fileWriter.write( "}\n" );
		fileWriter.close();

		String cmd[] = new String[ 6 ];
		cmd[ 0 ] = "dot";
		cmd[ 1 ] = "-T";
		cmd[ 2 ] = "png";
		cmd[ 3 ] = "-o";
		cmd[ 4 ] = dotcominfo.getAbsolutePath();
		cmd[ 5 ] = IMEnvBase.getEnv( "TMP" ) + "/dotcomgraph.dot";
	
		Helper.runCommand( cmd, null );

		String cmd2[] = new String[ 6 ];
		cmd2[ 0 ] = "dot";
		cmd2[ 1 ] = "-T";
		cmd2[ 2 ] = "cmap";
		cmd2[ 3 ] = "-o";
		cmd2[ 4 ] = infomap.getAbsolutePath();
		cmd2[ 5 ] = IMEnvBase.getEnv( "TMP" ) + "/dotcomgraph.dot";

		Helper.runCommand( cmd2, null );
	}
%>
<IMG SRC="/main/data/dotcominfo.png" usemap="#mapdotcom">
<MAP name="mapdotcom">
<%
	
	BufferedReader br = new BufferedReader( new FileReader( IMEnvBase.getEnv( "MAIN_DATA" ) + "/dotcominfo.cmap" ) );
	String cmapLine = null;
	while ( null != ( cmapLine = br.readLine() ) ) {
		if ( !isInFrame ) {
			out.println( cmapLine );
			continue;
		}
		int posHref = cmapLine.indexOf( "href" );
		int p1 = cmapLine.indexOf( "\"", posHref );
		int p2 = cmapLine.indexOf( "\"", p1 + 1 );
		String deviceId = cmapLine.substring( p1 + 1, p2 );
		out.print( cmapLine.substring( 0, p1 + 1 ) );
		out.print( "JavaScript:goparent_('" + deviceId + "');" );
		out.println( cmapLine.substring( p2 ) );
	}
	br.close();

%>
</MAP>

</TD></TR></TABLE>

</BODY></HTML>